package sound.player;

import futils.Futil;
import gui.In;

import javax.sound.sampled.*;

/**
 * Copyright DocJava, inc. User: lyon
 * <p/>
 * Date: Dec 28, 2004
 * <p/>
 * Time: 1:38:08 PM
 */
public class FromFile {
    public static void main(String[] args) {
        do
            playAudioFromFile();
        while(In.getBoolean("again?"));
    }
    public static void playAudioFromFile() {
        try {
            // From file
            AudioInputStream stream = AudioSystem.getAudioInputStream(
                    Futil.getReadFile("select an audio file"));
            // At present, ALAW and ULAW encodings must be converted
            // to PCM_SIGNED before it can be played
            AudioFormat format = stream.getFormat();
            if (format.getEncoding() != AudioFormat.Encoding.PCM_SIGNED) {
                format = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED,
                        format.getSampleRate(),
                        format.getSampleSizeInBits() * 2,
                        format.getChannels(),
                        format.getFrameSize() * 2,
                        format.getFrameRate(),
                        true);        // big endian
                stream = AudioSystem.getAudioInputStream(format, stream);
            }

            // Create the clip
            DataLine.Info info = new DataLine.Info(Clip.class,
                    stream.getFormat(),
                    ((int) stream.getFrameLength() * format.getFrameSize()));
            Clip clip = (Clip) AudioSystem.getLine(info);

            // This method does not return until the audio file is completely loaded
            clip.open(stream);

            // Start playing
            clip.start();
        } catch (Exception e) {
            In.message(e);

        }

    }
}
